////////////////////////////////////////////////////////////////////////
// alldemos.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <tnt/comploader.h>
#include <tnt/tntconfig.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.alldemos")

// <%pre>
#line 1 "alldemos.ecpp"

#include <fstream>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    // <%config>
    static std::string filename;
    // </%config>

};

class _component_Factory : public tnt::ComponentFactoryImpl<_component_>
{
  public:
    _component_Factory()
      : tnt::ComponentFactoryImpl<_component_>("alldemos")
      { }
    tnt::Component* doCreate(const tnt::Compident& ci,
      const tnt::Urlmapper& um, tnt::Comploader& cl);
    virtual void doConfigure(const tnt::TntConfig& config);
};

tnt::Component* _component_Factory::doCreate(const tnt::Compident& ci,
  const tnt::Urlmapper& um, tnt::Comploader& cl)
{
  return new _component_(ci, um, cl);
}

void _component_Factory::doConfigure(const tnt::TntConfig& config)
{
  // <%config>
  config.config.getMember("filename", _component_::filename);
  // </%config>
}

static _component_Factory factory;

static const char* rawData = "\034\000\000\000\?\002\000\000_\002\000\000a\002\000\000~\002\000\000\222\002\000\000\256"
  "\002\000\000<html>\n <head>\n  <style type=\"text/css\">\n   table {\n     width: 100%;\n     border: 3px solid black"
  ";\n     padding: 0;\n     border-spacing: 0;\n   }\n   th {\n     border: 1px solid black;\n     border-bottom: 2px s"
  "olid black;\n     background-color: #ffe;\n   }\n   td {\n     border: 1px solid black;\n     padding-left: 3;\n     "
  "padding-right: 10;\n     padding-top: 1;\n     padding-bottom: 1;\n   }\n  </style>\n </head>\n <body>\n  <h1>Tntnet-"
  "demos-page</h1>\n  <table style=\"border: 1px solid black\">\n   <tr>\n    <th>Demo</th>\n    <th>Desciption</th>\n  "
  " </tr>\n\n   <tr>\n    <td>\n     <a href=\"\"></a>\n    </td>\n    <td>\n     \n    </td>\n   </tr>\n  </table>\n </"
  "body>\n</html>\n";

// <%shared>
// </%shared>

// <%config>
std::string _component_::filename =  "demos.txt";
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("alldemos " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%cpp>
#line 7 "alldemos.ecpp"


std::ifstream demos(filename.c_str());


  reply.out() << data[0]; // <html>\n <head>\n  <style type="text/css">\n   table {\n     width: 100%;\n     border: 3px solid black;\n     padding: 0;\n     border-spacing: 0;\n   }\n   th {\n     border: 1px solid black;\n     border-bottom: 2px solid black;\n     background-color: #ffe;\n   }\n   td {\n     border: 1px solid black;\n     padding-left: 3;\n     padding-right: 10;\n     padding-top: 1;\n     padding-bottom: 1;\n   }\n  </style>\n </head>\n <body>\n  <h1>Tntnet-demos-page</h1>\n  <table style="border: 1px solid black">\n   <tr>\n    <th>Demo</th>\n    <th>Desciption</th>\n   </tr>\n
#line 42 "alldemos.ecpp"

  while (demos)
  {
    // read line
    std::string line;
    getline(demos, line);

    // find delimiters '|'
    std::string::size_type n0 = line.find('|');
    if (n0 == std::string::npos)
      continue;
    std::string::size_type n1 = line.find('|', n0 + 1);
    if (n1 == std::string::npos)
      continue;

    // extract parts
    std::string url(line, 0, n0);
    std::string name(line, n0 + 1, n1 - n0 - 1);
    std::string description(line, n1 + 1);

    // skip empty urls and lines starting with '#'
    if (url.empty() || line[0] == '#')
      continue;

  reply.out() << data[1]; // \n   <tr>\n    <td>\n     <a href="
#line 68 "alldemos.ecpp"
  reply.sout() << ( url );
  reply.out() << data[2]; // ">
#line 68 "alldemos.ecpp"
  reply.sout() << ( name );
  reply.out() << data[3]; // </a>\n    </td>\n    <td>\n     
#line 71 "alldemos.ecpp"
  reply.sout() << ( description );
  reply.out() << data[4]; // \n    </td>\n   </tr>\n
#line 74 "alldemos.ecpp"
 }

  reply.out() << data[5]; //   </table>\n </body>\n</html>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
