////////////////////////////////////////////////////////////////////////
// backgroundjob.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.backgroundjob")

// <%pre>
#line 1 "global.ecpp"

#include <set>
#include <tnt/backgroundworker.h>

#line 8 "backgroundjob.ecpp"


#include <cxxtools/thread.h>

class Report : public tnt::BackgroundTask
{
  public:
    Report()
      : tnt::BackgroundTask(cxxtools::Timespan(10, 0))
      { }
    void execute();
};

// simulate a long running task
void Report::execute()
{
    while (progress() < 100)
    {
        // do the work
        cxxtools::Thread::sleep(100);
        updateProgress(progress() + 1);
    }

}


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("backgroundjob");

static const char* rawData = "\014\000\000\000l\002\000\000\204\002\000\000<html>\n<head>\n    <title>Background job de"
  "mo</title>\n</head>\n<body>\n  <script src=\"ajax\" type=\"text/javascript\"></script>\n  <script type=\"text/javascr"
  "ipt\">\n     window.setInterval(\"updateStatus()\", 1000);\n\n     function updateStatus()\n     {\n       ajaxGet(\""
  "status\", function (request) {\n         document.getElementById(\"status\")\n            .innerHTML = request.respon"
  "seText;\n       });\n     }\n\n  </script>\n    <form method=\"post\">\n        <input type=\"submit\" name=\"start\""
  " value=\"start new job\">\n        <input type=\"submit\" name=\"cleanup\" value=\"remove timed out jobs\">\n    </fo"
  "rm>\n\n    <div id=\"status\"></div>\n\n</body>\n</html>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("backgroundjob " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
bool start = tnt::stringTo<bool>("start", "bool", qparam.param("start"), reply.out().getloc());
bool cleanup = tnt::stringTo<bool>("cleanup", "bool", qparam.param("cleanup"), reply.out().getloc());
  // </%args>

#line 6 "global.ecpp"
  typedef std::set<unsigned> activeJobs_type;
  TNT_SESSION_GLOBAL_VAR(activeJobs_type, activeJobs, "std::set<unsigned> activeJobs", ());   // <%session> std::set<unsigned> activeJobs
  // <%cpp>
  // <%include> global.ecpp
  // </%include>
#line 34 "backgroundjob.ecpp"


if (start)
{
    unsigned id = tnt::BackgroundWorker::it().runTask(new Report());
    activeJobs.insert(id);
}

if (cleanup)
{
    for (std::set<unsigned>::iterator it = activeJobs.begin(); it != activeJobs.end(); )
    {
        if (tnt::BackgroundWorker::it().getTask(*it))
            ++it;
        else
        {
            activeJobs.erase(it);
            it = activeJobs.begin();
        }
    }
}


  reply.out() << data[0]; // <html>\n<head>\n    <title>Background job demo</title>\n</head>\n<body>\n  <script src="ajax" type="text/javascript"></script>\n  <script type="text/javascript">\n     window.setInterval("updateStatus()", 1000);\n\n     function updateStatus()\n     {\n       ajaxGet("status", function (request) {\n         document.getElementById("status")\n            .innerHTML = request.responseText;\n       });\n     }\n\n  </script>\n    <form method="post">\n        <input type="submit" name="start" value="start new job">\n        <input type="submit" name="cleanup" value="remove timed out jobs">\n    </form>\n\n    <div id="status">
  // <& status ...
  { 
#line 80 "backgroundjob.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 80 "backgroundjob.ecpp"
    callComp(tnt::Compident(std::string(), "status"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[1]; // </div>\n\n</body>\n</html>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
