////////////////////////////////////////////////////////////////////////
// status.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.status")

// <%pre>
#line 1 "global.ecpp"

#include <set>
#include <tnt/backgroundworker.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("status");

static const char* rawData = "(\000\000\000\001\001\000\000\023\001\000\000\031\001\000\000*\001\000\000H\001\000\000T"
  "\001\000\000\206\001\000\000\220\001\000\000\234\001\000\000    <table border=\"1\">\n    <colgroup>\n     <col width"
  "=\"50px\">\n     <col width=\"80px\">\n     <col width=\"800px\">\n    </colgroup>\n    <tr>\n     <th style=\"width:"
  "50px\">id</th>\n     <th colspan=\"2\">progress</th>\n    </tr>\n    <tr>\n     <td></td>\n     <td>\n       %\n     "
  "</td>\n     <td>\n       \n     </td>\n     <td colspan=\"2\">\n       timed out\n     </td>\n    </tr>\n  </table>\n"
  "\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("status " << qparam.getUrl());

  tnt::DataChunks data(rawData);

#line 6 "global.ecpp"
  typedef std::set<unsigned> activeJobs_type;
  TNT_SESSION_GLOBAL_VAR(activeJobs_type, activeJobs, "std::set<unsigned> activeJobs", ());   // <%session> std::set<unsigned> activeJobs
  // <%cpp>
  // <%include> global.ecpp
  // </%include>
  reply.out() << data[0]; //     <table border="1">\n    <colgroup>\n     <col width="50px">\n     <col width="80px">\n     <col width="800px">\n    </colgroup>\n    <tr>\n     <th style="width:50px">id</th>\n     <th colspan="2">progress</th>\n    </tr>\n
#line 14 "status.ecpp"
 for (std::set<unsigned>::const_iterator it = activeJobs.begin(); it != activeJobs.end(); ++it) {

  reply.out() << data[1]; //     <tr>\n     <td>
#line 16 "status.ecpp"
  reply.sout() << (*it);
  reply.out() << data[2]; // </td>\n
#line 17 "status.ecpp"
   tnt::BackgroundTask::Pointer ptr = tnt::BackgroundWorker::it().getTask(*it);

#line 18 "status.ecpp"
   if (ptr) {

  reply.out() << data[3]; //      <td>\n       
#line 20 "status.ecpp"
  reply.sout() << (ptr->progress());
  reply.out() << data[4]; // %\n     </td>\n     <td>\n       
#line 23 "status.ecpp"
  reply.sout() << (std::string(ptr->progress(), '*'));
  reply.out() << data[5]; // \n     </td>\n
#line 25 "status.ecpp"
   } else {

  reply.out() << data[6]; //      <td colspan="2">\n       timed out\n     </td>\n
#line 29 "status.ecpp"
   }

  reply.out() << data[7]; //     </tr>\n
#line 31 "status.ecpp"
 }

  reply.out() << data[8]; //   </table>\n\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
