////////////////////////////////////////////////////////////////////////
// calc.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.calc")

// <%pre>
// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("calc");

static const char* rawData = "0\000\000\0001\000\000\000\256\000\000\000\330\000\000\000\t\001\000\000\327\001\000\000"
  "\341\001\000\000\342\001\000\000\343\001\000\000\346\001\000\000\350\001\000\000\372\001\000\000 \n<html>\n <head>\n "
  " <title>Calculator</title>\n </head>\n <body bgcolor=#ffffcc>\n  <h1>Tommi's Tnt-Calculator</h1>\n\n  <form>\n\n   \n"
  "   <input type=\"text\" name=\"arg1\" value=\"\"> <br>\n   <input type=\"text\" name=\"arg2\" value=\"\"> <br>\n   <i"
  "nput type=\"submit\" name=\"plus\" value=\"+\">\n   <input type=\"submit\" name=\"minus\" value=\"-\">\n   <input typ"
  "e=\"submit\" name=\"mul\" value=\"*\">\n   <input type=\"submit\" name=\"div\" value=\"/\">\n  </form>\n\n\n  <hr>\n "
  "    = \n\n\n </body>\n</html>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("calc " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
double arg1 = qparam.has("arg1") ? tnt::stringToWithDefault<double>(qparam.param("arg1"), ( 0), reply.out().getloc()) : ( 0);
double arg2 = qparam.has("arg2") ? tnt::stringToWithDefault<double>(qparam.param("arg2"), ( 0), reply.out().getloc()) : ( 0);
bool plus = tnt::stringTo<bool>("plus", "bool", qparam.param("plus"), reply.out().getloc());
bool minus = tnt::stringTo<bool>("minus", "bool", qparam.param("minus"), reply.out().getloc());
bool mul = tnt::stringTo<bool>("mul", "bool", qparam.param("mul"), reply.out().getloc());
bool div = tnt::stringTo<bool>("div", "bool", qparam.param("div"), reply.out().getloc());
  // </%args>

  // <%cpp>
#line 9 "calc.ecpp"
  // <= this starts a c++-processing-block

  double result = 0.0;
  char op = '\0';

  if (plus)
  {
    result = arg1 + arg2;
    op = '+';
  }
  else if (minus)
  {
    result = arg1 - arg2;
    op = '-';
  }
  else if (mul)
  {
    result = arg1 * arg2;
    op = '*';
  }
  else if (div)
  {
    result = arg1 / arg2;
    op = '/';
  }


  reply.out() << data[0]; //  
  reply.out() << data[1]; // \n<html>\n <head>\n  <title>Calculator</title>\n </head>\n <body bgcolor=#ffffcc>\n  <h1>Tommi's Tnt-Calculator</h1>\n\n  <form>\n\n   
  reply.out() << data[2]; // \n   <input type="text" name="arg1" value="
#line 47 "calc.ecpp"
  reply.sout() << (arg1);
  reply.out() << data[3]; // "> <br>\n   <input type="text" name="arg2" value="
#line 48 "calc.ecpp"
  reply.sout() << (arg2);
  reply.out() << data[4]; // "> <br>\n   <input type="submit" name="plus" value="+">\n   <input type="submit" name="minus" value="-">\n   <input type="submit" name="mul" value="*">\n   <input type="submit" name="div" value="/">\n  </form>\n\n
#line 55 "calc.ecpp"
 if (op) {    // '%' in the first column makes a c++-one-liner

  reply.out() << data[5]; // \n  <hr>\n  
#line 58 "calc.ecpp"
  reply.sout() << (arg1);
  reply.out() << data[6]; //  
#line 58 "calc.ecpp"
  reply.sout() << (op);
  reply.out() << data[7]; //  
#line 58 "calc.ecpp"
  reply.sout() << (arg2);
  reply.out() << data[8]; //  = 
#line 58 "calc.ecpp"
  reply.sout() << (result);
  reply.out() << data[9]; // \n\n
#line 60 "calc.ecpp"
 }

  reply.out() << data[10]; // \n </body>\n</html>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
