////////////////////////////////////////////////////////////////////////
// calcajax.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.calcajax")

// <%pre>
// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("calcajax");

static const char* rawData = "\010\000\000\000T\004\000\000<html>\n <head>\n  <title>Calculator</title>\n  <script src="
  "\"calcajax_js\" type=\"text/javascript\">\n  </script>\n  <script type=\"text/javascript\">\n    function calc(op)\n "
  "   {\n      var arg1 = document.getElementById(\"arg1\").value;\n      var arg2 = document.getElementById(\"arg2\").v"
  "alue;\n      var url = \"docalc\?arg1=\" + escape(arg1)\n              + \"&arg2=\" + escape(arg2)\n              + "
  "\"&op=\" + escape(op);\n\n      ajaxGet(url,\n        function(request)\n        {\n          var e = document.getEle"
  "mentById(\"result\");\n          e.innerHTML = request.responseText;\n          e.style.display = \"block\";\n       "
  " } );\n    }\n  </script>\n </head>\n <body bgcolor=#ffffcc>\n  <h1>Tommi's Tnt-Calculator</h1>\n\n  <form>\n   <inpu"
  "t type=\"text\" value=\"0\" id=\"arg1\"> <br>\n   <input type=\"text\" value=\"0\" id=\"arg2\"> <br>\n   <input type="
  "\"button\" value=\"+\" onClick=\"calc('p')\">\n   <input type=\"button\" value=\"-\" onClick=\"calc('-')\">\n   <inpu"
  "t type=\"button\" value=\"*\" onClick=\"calc('*')\">\n   <input type=\"button\" value=\"/\" onClick=\"calc('/')\">\n "
  " </form>\n\n  <div id=\"result\" style=\"display:none\">\n\n  </div>\n\n </body>\n</html>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("calcajax " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%cpp>
  reply.out() << data[0]; // <html>\n <head>\n  <title>Calculator</title>\n  <script src="calcajax_js" type="text/javascript">\n  </script>\n  <script type="text/javascript">\n    function calc(op)\n    {\n      var arg1 = document.getElementById("arg1").value;\n      var arg2 = document.getElementById("arg2").value;\n      var url = "docalc\?arg1=" + escape(arg1)\n              + "&arg2=" + escape(arg2)\n              + "&op=" + escape(op);\n\n      ajaxGet(url,\n        function(request)\n        {\n          var e = document.getElementById("result");\n          e.innerHTML = request.responseText;\n          e.style.display = "block";\n        } );\n    }\n  </script>\n </head>\n <body bgcolor=#ffffcc>\n  <h1>Tommi's Tnt-Calculator</h1>\n\n  <form>\n   <input type="text" value="0" id="arg1"> <br>\n   <input type="text" value="0" id="arg2"> <br>\n   <input type="button" value="+" onClick="calc('p')">\n   <input type="button" value="-" onClick="calc('-')">\n   <input type="button" value="*" onClick="calc('*')">\n   <input type="button" value="/" onClick="calc('/')">\n  </form>\n\n  <div id="result" style="display:none">\n\n  </div>\n\n </body>\n</html>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
