////////////////////////////////////////////////////////////////////////
// calcajax_js.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.calcajax_js")

// <%pre>
// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("calcajax_js");

static const char* rawData = "\010\000\000\000U\002\000\000function getRequest()\n{\n  try { return new XMLHttpRequest("
  ");                   } catch (e) { }\n  try { return new ActiveXObject(\"Msxml2.XMLHttp\");    } catch (e) { }\n  try"
  " { return new ActiveXObject(\"Microsoft.XMLHTTP\"); } catch (e) { }\n  return null;\n}\n\nfunction ajaxGet(url, fn, f"
  "ailFn)\n{\n  request = getRequest();\n  request.open(\"GET\", url);\n  request.onreadystatechange = function () {\n  "
  "    if (request.readyState == 4)\n      {\n        if (request.status == 200)\n          fn(request);\n        else i"
  "f (failFn != null)\n          failFn(request);\n      }\n    }\n  request.send(null);\n}\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("calcajax_js " << qparam.getUrl());

  reply.setContentType("application/x-javascript");
  tnt::DataChunks data(rawData);

  // <%cpp>
  reply.out() << data[0]; // function getRequest()\n{\n  try { return new XMLHttpRequest();                   } catch (e) { }\n  try { return new ActiveXObject("Msxml2.XMLHttp");    } catch (e) { }\n  try { return new ActiveXObject("Microsoft.XMLHTTP"); } catch (e) { }\n  return null;\n}\n\nfunction ajaxGet(url, fn, failFn)\n{\n  request = getRequest();\n  request.open("GET", url);\n  request.onreadystatechange = function () {\n      if (request.readyState == 4)\n      {\n        if (request.status == 200)\n          fn(request);\n        else if (failFn != null)\n          failFn(request);\n      }\n    }\n  request.send(null);\n}\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
