////////////////////////////////////////////////////////////////////////
// docalc.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.docalc")

// <%pre>
// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("docalc");

static const char* rawData = "\030\000\000\000\035\000\000\000\036\000\000\000\037\000\000\000\"\000\000\000#\000\000"
  "\000<hr>\n   = \n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("docalc " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
double arg1 = tnt::stringTo<double>("arg1", "double", qparam.param("arg1"), reply.out().getloc());
double arg2 = tnt::stringTo<double>("arg2", "double", qparam.param("arg2"), reply.out().getloc());
char op = tnt::stringTo<char>("op", "char", qparam.param("op"), reply.out().getloc());
  // </%args>

  // <%cpp>
#line 6 "docalc.ecpp"


  double result = 0.0;

  bool result_ok = true;
  if (op == 'p')
    op = '+';
  switch (op)
  {
    case '+': result = arg1 + arg2; break;
    case '-': result = arg1 - arg2; break;
    case '*': result = arg1 * arg2; break;
    case '/': result = arg1 / arg2; break;
    default: result_ok = false;
  }


#line 23 "docalc.ecpp"
 if (result_ok) {

  reply.out() << data[0]; // <hr>\n
#line 25 "docalc.ecpp"
  reply.sout() << (arg1);
  reply.out() << data[1]; //  
#line 25 "docalc.ecpp"
  reply.sout() << (op);
  reply.out() << data[2]; //  
#line 25 "docalc.ecpp"
  reply.sout() << (arg2);
  reply.out() << data[3]; //  = 
#line 25 "docalc.ecpp"
  reply.sout() << (result);
  reply.out() << data[4]; // \n
#line 26 "docalc.ecpp"
 }

  // <%/cpp>
  return HTTP_OK;
}

} // namespace
