////////////////////////////////////////////////////////////////////////
// calci18n.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.calci18n")

// <%pre>
// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("calci18n");

static const char* rawData = "T\000\000\000l\000\000\000v\000\000\000\246\000\000\000\274\000\000\000\322\000\000\000"
  "\326\000\000\000\333\000\000\000\005\001\000\0006\001\000\000\363\001\000\000\"\002\000\000.\002\000\000;\002\000\000"
  "H\002\000\000O\002\000\000P\002\000\000Q\002\000\000T\002\000\000]\002\000\000\357\002\000\000<html>\n <head>\n  <tit"
  "le>Calculator</title>\n </head>\n <body bgcolor=#ffffcc>\n  <h1>Tommi's Tnt-Calculator</h1>\n\n  <form method=>   \n"
  "\n   \n   <input type=\"text\" name=\"arg1\" value=\"\"> <br>\n   <input type=\"text\" name=\"arg2\" value=\"\"> <br>"
  "\n   <input type=\"submit\" name=\"op\" value=\"+\">\n   <input type=\"submit\" name=\"op\" value=\"-\">\n   <input t"
  "ype=\"submit\" name=\"op\" value=\"*\">\n   <input type=\"submit\" name=\"op\" value=\"/\">\n\n\n   <input type=hidde"
  "n name=method value=get>\n\n\n  </form>\n\n\n  <hr>\n  <p>the result is<br>\n     = \n  </p>\n\n\n <a href=\"\?LANG="
  "\"><img src=\"en.png\"></a>\n <a href=\"\?LANG=fi\"><img src=\"fi.png\"></a>\n <a href=\"\?LANG=de\"><img src=\"de.pn"
  "g\"></a>\n\n </body>\n</html>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
       data.setData(getData(request, rawData)); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("calci18n " << qparam.getUrl());

  tnt::DataChunks data(getData(request, rawData));

  // <%args>
double arg1 = qparam.has("arg1") ? tnt::stringToWithDefault<double>(qparam.param("arg1"), ( 0), reply.out().getloc()) : ( 0);
double arg2 = qparam.has("arg2") ? tnt::stringToWithDefault<double>(qparam.param("arg2"), ( 0), reply.out().getloc()) : ( 0);
char op = qparam.has("op") ? tnt::stringToWithDefault<char>(qparam.param("op"), ( ' '), reply.out().getloc()) : ( ' ');
std::string method = qparam.param("method", ( "post"));
  // </%args>

  // <%cpp>
#line 7 "calci18n.ecpp"


  double result = 0.0;

  bool result_ok = true;
  switch (op)
  {
    case '+': result = arg1 + arg2; break;
    case '-': result = arg1 - arg2; break;
    case '*': result = arg1 * arg2; break;
    case '/': result = arg1 / arg2; break;
    default: result_ok = false;
  }


  reply.out() << data[0]; // <html>\n <head>\n  <title>
  reply.out() << data[1]; // Calculator
  reply.out() << data[2]; // </title>\n </head>\n <body bgcolor=#ffffcc>\n  <h1>
  reply.out() << data[3]; // Tommi's Tnt-Calculator
  reply.out() << data[4]; // </h1>\n\n  <form method=
#line 30 "calci18n.ecpp"
  reply.sout() << (method);
  reply.out() << data[5]; // >   
  reply.out() << data[6]; // \n\n   
  reply.out() << data[7]; // \n   <input type="text" name="arg1" value="
#line 34 "calci18n.ecpp"
  reply.sout() << (arg1);
  reply.out() << data[8]; // "> <br>\n   <input type="text" name="arg2" value="
#line 35 "calci18n.ecpp"
  reply.sout() << (arg2);
  reply.out() << data[9]; // "> <br>\n   <input type="submit" name="op" value="+">\n   <input type="submit" name="op" value="-">\n   <input type="submit" name="op" value="*">\n   <input type="submit" name="op" value="/">\n\n
#line 41 "calci18n.ecpp"
 if (method == "get") {    // '%' in the first column makes a c++-one-liner

  reply.out() << data[10]; // \n   <input type=hidden name=method value=get>\n\n
#line 45 "calci18n.ecpp"
 }

  reply.out() << data[11]; // \n  </form>\n\n
#line 49 "calci18n.ecpp"
 if (result_ok) {

  reply.out() << data[12]; // \n  <hr>\n  <p>
  reply.out() << data[13]; // the result is
  reply.out() << data[14]; // <br>\n  
#line 53 "calci18n.ecpp"
  reply.sout() << (arg1);
  reply.out() << data[15]; //  
#line 53 "calci18n.ecpp"
  reply.sout() << (op);
  reply.out() << data[16]; //  
#line 53 "calci18n.ecpp"
  reply.sout() << (arg2);
  reply.out() << data[17]; //  = 
#line 53 "calci18n.ecpp"
  reply.sout() << (result);
  reply.out() << data[18]; // \n  </p>\n\n
#line 56 "calci18n.ecpp"
 }

  reply.out() << data[19]; // \n <a href="\?LANG="><img src="en.png"></a>\n <a href="\?LANG=fi"><img src="fi.png"></a>\n <a href="\?LANG=de"><img src="de.png"></a>\n\n </body>\n</html>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
