////////////////////////////////////////////////////////////////////////
// calcView.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.calcView")

// <%pre>
#line 1 "calcModel.ecpp"

#include "calcBean.h"

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("calcView");

static const char* rawData = "(\000\000\000X\000\000\000\202\000\000\000\263\000\000\000z\001\000\000\204\001\000\000"
  "\205\001\000\000\206\001\000\000\211\001\000\000\213\001\000\000  <h1>Tommi's Tnt-Calculator</h1>\n\n  <form>\n\n   "
  "\n   <input type=\"text\" name=\"arg1\" value=\"\"> <br>\n   <input type=\"text\" name=\"arg2\" value=\"\"> <br>\n   "
  "<input type=\"submit\" name=\"op\" value=\"+\">\n   <input type=\"submit\" name=\"op\" value=\"-\">\n   <input type="
  "\"submit\" name=\"op\" value=\"*\">\n   <input type=\"submit\" name=\"op\" value=\"/\">\n  </form>\n\n\n  <hr>\n     "
  "= \n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("calcView " << qparam.getUrl());

  tnt::DataChunks data(rawData);

#line 5 "calcModel.ecpp"
  typedef calcBean calc_type;
  TNT_REQUEST_GLOBAL_VAR(calc_type, calc, "calcBean calc", ());   // <%request> calcBean calc
  // <%cpp>
  // <%include> calcModel.ecpp
  // </%include>
  reply.out() << data[0]; //   <h1>Tommi's Tnt-Calculator</h1>\n\n  <form>\n\n   
  reply.out() << data[1]; // \n   <input type="text" name="arg1" value="
#line 8 "calcView.ecpp"
  reply.sout() << (calc.getArg1());
  reply.out() << data[2]; // "> <br>\n   <input type="text" name="arg2" value="
#line 9 "calcView.ecpp"
  reply.sout() << (calc.getArg2());
  reply.out() << data[3]; // "> <br>\n   <input type="submit" name="op" value="+">\n   <input type="submit" name="op" value="-">\n   <input type="submit" name="op" value="*">\n   <input type="submit" name="op" value="/">\n  </form>\n\n
#line 16 "calcView.ecpp"
 if (calc.isResultOk()) {

  reply.out() << data[4]; // \n  <hr>\n  
#line 19 "calcView.ecpp"
  reply.sout() << (calc.getArg1());
  reply.out() << data[5]; //  
#line 19 "calcView.ecpp"
  reply.sout() << (calc.getOp());
  reply.out() << data[6]; //  
#line 19 "calcView.ecpp"
  reply.sout() << (calc.getArg2());
  reply.out() << data[7]; //  = 
#line 19 "calcView.ecpp"
  reply.sout() << (calc.getResult());
  reply.out() << data[8]; // \n\n
#line 21 "calcView.ecpp"
 }

  // <%/cpp>
  return HTTP_OK;
}

} // namespace
