////////////////////////////////////////////////////////////////////////
// chat.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.chat")

// <%pre>
// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("chat");

static const char* rawData = "\014\000\000\000\315\003\000\000\324\010\000\000<html>\n <head>\n  <title>ecpp-applicatio"
  "n chat</title>\n  <script src=\"ajax\" type=\"text/javascript\"></script>\n  <script type=\"text/javascript\">\n\n   "
  "window.setInterval(\"updateChat()\", 500);\n\n   function jsonRequest(request)\n   {\n     if (request.responseText !"
  "= this.oldContent)\n     {\n       this.oldContent = request.responseText;\n\n       var content = JSON.parse(request"
  ".responseText);\n       var c = document.getElementById(\"chat\");\n       var newContent = \"<table>\";\n\n       fo"
  "r(var i = 0; i < content.length; ++i)\n       {\n         obj = content[i];\n         newContent += \"<tr>\"\n       "
  "              + \"<td class='person'>\"\n                     + obj.person\n                     + \"</td>\"\n       "
  "              + \"<td class='message'>\"\n                     + obj.message\n                     + \"</td>\"\n     "
  "                + \"</tr>\";\n       }\n\n       newContent += \"</table>\";\n       c.innerHTML = newContent;\n     "
  "}\n   }\n\n   function updateChat()\n   {\n     \n     ajaxGet(\"getchat\", null, jsonRequest);\n   }\n\n   function "
  "sendMessage()\n   {\n     var p = document.getElementById(\"person\");\n     var m = document.getElementById(\"messag"
  "e\");\n     ajaxGet(\"putchat\",\n       \"person=\" + escape(p.value) + \"&message=\" + escape(m.value),\n       jso"
  "nRequest);\n     m.value = \"\";\n     m.focus();\n   }\n\n   function addText(t)\n   {\n     var m = document.getEle"
  "mentById(\"message\");\n     m.value += t;\n   }\n\n  </script>\n  <style type=\"text/css\">\n   .person {\n     font"
  "-weight: bold;\n   }\n   .message {\n     color: blue;\n   }\n  </style>\n </head>\n <body>\n  <h1>Ajaxchat</h1>\n\n "
  " <form>\n   <table>\n    <tr>\n     <td>\n      your Name\n     </td>\n     <td>\n      <input type=\"text\" name=\"p"
  "erson\" id=\"person\" size=\"20\">\n     </td>\n    </tr>\n    <tr>\n     <td>\n      your Message\n     </td>\n     "
  "<td>\n      <input type=\"text\" name=\"message\" id=\"message\" size=\"80\"><br>\n     </td>\n    </tr>\n   </table>"
  "\n   <input type=\"button\" value=\"talk\" onClick=\"sendMessage()\">\n   <img src=\"smile\" onClick='addText(\" :) "
  "\")'>\n   <img src=\"sad\" onClick='addText(\" :( \")'>\n   <img src=\"wink\" onClick='addText(\" ;) \")'>\n  </form>"
  "\n  <script type=\"text/javascript\">\n   document.getElementById(\"person\").focus();\n  </script>\n\n  <hr>\n  <div"
  " id=\"chat\"><table></table></div>\n\n </body>\n</html>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("chat " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%cpp>
  reply.out() << data[0]; // <html>\n <head>\n  <title>ecpp-application chat</title>\n  <script src="ajax" type="text/javascript"></script>\n  <script type="text/javascript">\n\n   window.setInterval("updateChat()", 500);\n\n   function jsonRequest(request)\n   {\n     if (request.responseText != this.oldContent)\n     {\n       this.oldContent = request.responseText;\n\n       var content = JSON.parse(request.responseText);\n       var c = document.getElementById("chat");\n       var newContent = "<table>";\n\n       for(var i = 0; i < content.length; ++i)\n       {\n         obj = content[i];\n         newContent += "<tr>"\n                     + "<td class='person'>"\n                     + obj.person\n                     + "</td>"\n                     + "<td class='message'>"\n                     + obj.message\n                     + "</td>"\n                     + "</tr>";\n       }\n\n       newContent += "</table>";\n       c.innerHTML = newContent;\n     }\n   }\n\n   function updateChat()\n   {\n     
  reply.out() << data[1]; // \n     ajaxGet("getchat", null, jsonRequest);\n   }\n\n   function sendMessage()\n   {\n     var p = document.getElementById("person");\n     var m = document.getElementById("message");\n     ajaxGet("putchat",\n       "person=" + escape(p.value) + "&message=" + escape(m.value),\n       jsonRequest);\n     m.value = "";\n     m.focus();\n   }\n\n   function addText(t)\n   {\n     var m = document.getElementById("message");\n     m.value += t;\n   }\n\n  </script>\n  <style type="text/css">\n   .person {\n     font-weight: bold;\n   }\n   .message {\n     color: blue;\n   }\n  </style>\n </head>\n <body>\n  <h1>Ajaxchat</h1>\n\n  <form>\n   <table>\n    <tr>\n     <td>\n      your Name\n     </td>\n     <td>\n      <input type="text" name="person" id="person" size="20">\n     </td>\n    </tr>\n    <tr>\n     <td>\n      your Message\n     </td>\n     <td>\n      <input type="text" name="message" id="message" size="80"><br>\n     </td>\n    </tr>\n   </table>\n   <input type="button" value="talk" onClick="sendMessage()">\n   <img src="smile" onClick='addText(" :) ")'>\n   <img src="sad" onClick='addText(" :( ")'>\n   <img src="wink" onClick='addText(" ;) ")'>\n  </form>\n  <script type="text/javascript">\n   document.getElementById("person").focus();\n  </script>\n\n  <hr>\n  <div id="chat"><table></table></div>\n\n </body>\n</html>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
