////////////////////////////////////////////////////////////////////////
// getchat.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <tnt/comploader.h>
#include <tnt/tntconfig.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.getchat")

// <%pre>
#line 1 "global.ecpp"


#include <list>
#include <string>
#include <cxxtools/serializationinfo.h>

struct chatMessage
{
  chatMessage() { }
  chatMessage(const std::string& person_, const std::string& message_, const int id_)
    : person(person_),
      message(message_),
      id(id_)
      { }

  std::string person;
  std::string message;
  int id;
};

typedef std::list<chatMessage> chat_type;

inline void operator<<= (cxxtools::SerializationInfo& si, const chatMessage& msg)
{
  si.addMember("id") <<= msg.id;
  si.addMember("person") <<= msg.person;
  si.addMember("message") <<= msg.message;
}


#line 2 "getchat.ecpp"


#include <tnt/httpheader.h>
#include <cxxtools/jsonserializer.h>


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    // <%config>
    static unsigned maxComments;
    // </%config>

};

class _component_Factory : public tnt::ComponentFactoryImpl<_component_>
{
  public:
    _component_Factory()
      : tnt::ComponentFactoryImpl<_component_>("getchat")
      { }
    tnt::Component* doCreate(const tnt::Compident& ci,
      const tnt::Urlmapper& um, tnt::Comploader& cl);
    virtual void doConfigure(const tnt::TntConfig& config);
};

tnt::Component* _component_Factory::doCreate(const tnt::Compident& ci,
  const tnt::Urlmapper& um, tnt::Comploader& cl)
{
  return new _component_(ci, um, cl);
}

void _component_Factory::doConfigure(const tnt::TntConfig& config)
{
  // <%config>
  config.config.getMember("maxComments", _component_::maxComments);
  // </%config>
}

static _component_Factory factory;

// <%shared>
// </%shared>

// <%config>
unsigned _component_::maxComments =  10;
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("getchat " << qparam.getUrl());


#line 38 "global.ecpp"
  typedef chat_type chat_type;
  TNT_APPLICATION_GLOBAL_VAR(chat_type, chat, "chat_type chat", ());   // <%application> chat_type chat
#line 39 "global.ecpp"
  typedef int maxID_type;
  TNT_APPLICATION_GLOBAL_VAR(maxID_type, maxID, "int maxID", (0));   // <%application> int maxID(0)
  // <%cpp>
  // <%include> global.ecpp
  // </%include>
#line 8 "getchat.ecpp"


  log_debug("getchat - " << chat.size() << " comments");

  reply.setHeader(tnt::httpheader::cacheControl, "no-cache");
  reply.setHeader(tnt::httpheader::contentType, "application/json");

  cxxtools::JsonSerializer s(reply.out());
  s.serialize(chat);
  s.finish();


  // <%/cpp>
  return HTTP_OK;
}

} // namespace
