////////////////////////////////////////////////////////////////////////
// comp.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.comp")

// <%pre>
// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class localcomp_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        localcomp_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class localcomp_p_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        localcomp_p_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam, int i);
    };

    localcomp_type localcomp;
    localcomp_p_type localcomp_p;
};

static tnt::ComponentFactoryImpl<_component_> Factory("comp");

static const char* rawData = "d\000\000\000)\010\000\000\303\010\000\000m\t\000\000\372\t\000\000\222\n\000\000\310\n"
  "\000\0006\013\000\000\344\013\000\000\201\014\000\000G\015\000\000\327\015\000\000\357\015\000\000F\016\000\000L\016"
  "\000\000z\016\000\000\200\016\000\000\211\016\000\000\235\016\000\000\316\016\000\000\356\016\000\000\360\016\000\000"
  "\361\016\000\000O\017\000\000\232\017\000\000<html>\n<head>\n <style type=\"text/css\">\n   p.example { background-co"
  "lor: #fcc;\n               font-family: monospace;\n               white-space: pre;; }\n   p.result { background-col"
  "or: #ccc; }\n </style>\n</head>\n<body>\n\n<h1>Calling subcomponents</h1>\n\n<p>\n<b>Ecpp</b>-pages can embed other p"
  "ages. These embedded pages are called\nsubcomponents. They come in 2 variants: local and external. Local\nsubcomponen"
  "ts are defined inside another component with\n<b>&lt;%def&nbsp;<i>componentname</i>&gt;</b> and closed with\n<b>&lt;/"
  "def&gt;</b>. External subcomponents are normal components.\n</p>\n\n<p>\nA subcomponentcall starts with <b>&lt;&amp;<"
  "/b> and ends with\n<b>&amp;&gt;</b>. Insert the componentname between these tags. If you omit the\nlibrary-part of th"
  "e component, the current library is used. If the\ncomponentname is a single word, ecpp looks for a local component, w"
  "hich is\ncalled if found. Otherwise it is a external componentcall.\n</p>\n\n<p>\nYou can dynamically build component"
  "names, by putting a c++-expression inside\nbrackets. This expression is evaluated on runtime and the resulting compon"
  "ent\nis called. The expression can be of type (or convertable to)\n<b>std::string</b>, <b>tnt::Compident</b> or <b>tn"
  "t::Subcompident</b>.\n</p>\n\n<p>\nAfter the componentname you can add named parameters. Put a name followed by\n'=' "
  "and a value. The value is either a constant string or a expression. A\nexpression must be bracketed. If you want to p"
  "ass just the same parameters\nyour current component received, put the single word <b>qparam</b> into the\nlist (actu"
  "ally you can pass any <b>cxxtools::query_params</b>-variable).\n</p>\n\n<p>\nA special case are local components, whi"
  "ch have c++-parameters. You can put a\nnormal parameterlist just like in c++-functions after the defition\n(<b>&lt;%d"
  "ef&gt;</b>-block) after the componentname. The can only be called locally.\n</p>\n\n<h2>Just a local componentcall</h"
  "2>\n\n<p class=\"example\">\n &lt;&amp; localcomp param1=\"value1\" &amp;&gt;\n</p>\n\n<p class=\"result\">\n \n</p>"
  "\n\n\n<h2> Another local componentcall. We pass a c++-parameter. </h2>\n<p class=\"example\">\n &lt;&amp; localcomp_p"
  "(5) &amp;&gt;\n</p>\n<p class=\"result\">\n \n</p>\n\n\n<h2>A external componentcall (localcomp \"extcomp\" does not "
  "exist)</h2>\n\n<p class=\"example\">\n &lt;&amp; subcomp param1=\"value1\" &amp;&gt;\n</p>\n<p class=\"result\">\n \n"
  "</p>\n\n<h2> a external componentcall </h2>\n\n<p class=\"example\">\n &lt;&amp; extcomp@extlib param1=\"value1\" &am"
  "p;&gt;\n</p>\n<p class=\"result\">\n \n</p>\n\n<h2> a external subcomponentcall </h2>\n\n<p class=\"example\">\n &lt;"
  "&amp; extcomp.subcomp@extlib param1=\"value1\" &amp;&gt;\n</p>\n<p class=\"result\">\n \n</p>\n\n<h2> compose compone"
  "ntname by expression </h2>\n\n<p class=\"example\">\n &lt;&amp; (compname + '@' + libname) param1=\"value1\" &amp;&gt"
  ";\n</p>\n<p class=\"result\">\n \n</p>\n\n<h2> call component by componentidentifier </h2>\n<p class=\"example\">\n &"
  "lt;&amp; (tnt::Compident(compname, libname)) param1=\"value1\" &amp;&gt;\n</p>\n<p class=\"result\">\n \n</p>\n\n<h2>"
  " pass a expression as parameter </h2>\n<p class=\"example\">\n &lt;&amp; localcomp param1=(1+5) qparam param2=\"uhu\""
  "&amp;&gt;\n</p>\n<p class=\"result\">\n \n</p>\n\n<h2> pass multiple values with the same name as parameter </h2>\n<p"
  " class=\"example\">\n &lt;&amp; localcomp param3=\"value1\" param3=\"value2\"\n              param4=\"17\" param4=(28"
  ") &amp;&gt;\n</p>\n \n\n<h2> call subcomponents in c++-blocks </h2>\n<p class=\"example\">\n  callComp(\"extcomp@extl"
  "ib\", request, reply, qparam);\n</p>\n<p class=\"result\">\n\n</p>\n\n</body>\n</html>\n\n   This is a local subcompo"
  "nent.\n   We got a parameter <i>param1</i> with the value <b></b>.\n   We got <i>param2</i> also. Its value is <b></b"
  ">.\n  We got  times \"param3\" and  times\n  \"param4\".\n  The values of param3 are:\n  .\n  The values of param4 ar"
  "e:\n  .\n\nThis is a local subcomponent with parameter.\nWe got a c++-integer-parameter with the value <b></b>.\nThis"
  " component can only be called locally because of c++-parameters.\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    localcomp(*this, "localcomp"),
    localcomp_p(*this, "localcomp_p")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("comp " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%cpp>
  reply.out() << data[0]; // <html>\n<head>\n <style type="text/css">\n   p.example { background-color: #fcc;\n               font-family: monospace;\n               white-space: pre;; }\n   p.result { background-color: #ccc; }\n </style>\n</head>\n<body>\n\n<h1>Calling subcomponents</h1>\n\n<p>\n<b>Ecpp</b>-pages can embed other pages. These embedded pages are called\nsubcomponents. They come in 2 variants: local and external. Local\nsubcomponents are defined inside another component with\n<b>&lt;%def&nbsp;<i>componentname</i>&gt;</b> and closed with\n<b>&lt;/def&gt;</b>. External subcomponents are normal components.\n</p>\n\n<p>\nA subcomponentcall starts with <b>&lt;&amp;</b> and ends with\n<b>&amp;&gt;</b>. Insert the componentname between these tags. If you omit the\nlibrary-part of the component, the current library is used. If the\ncomponentname is a single word, ecpp looks for a local component, which is\ncalled if found. Otherwise it is a external componentcall.\n</p>\n\n<p>\nYou can dynamically build componentnames, by putting a c++-expression inside\nbrackets. This expression is evaluated on runtime and the resulting component\nis called. The expression can be of type (or convertable to)\n<b>std::string</b>, <b>tnt::Compident</b> or <b>tnt::Subcompident</b>.\n</p>\n\n<p>\nAfter the componentname you can add named parameters. Put a name followed by\n'=' and a value. The value is either a constant string or a expression. A\nexpression must be bracketed. If you want to pass just the same parameters\nyour current component received, put the single word <b>qparam</b> into the\nlist (actually you can pass any <b>cxxtools::query_params</b>-variable).\n</p>\n\n<p>\nA special case are local components, which have c++-parameters. You can put a\nnormal parameterlist just like in c++-functions after the defition\n(<b>&lt;%def&gt;</b>-block) after the componentname. The can only be called locally.\n</p>\n\n<h2>Just a local componentcall</h2>\n\n<p class="example">\n &lt;&amp; localcomp param1="value1" &amp;&gt;\n</p>\n\n<p class="result">\n 
  // <& localcomp ...
  { 
#line 58 "comp.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 58 "comp.ecpp"
    _tnt_cq0.add( "param1", tnt::toString("value1", reply.out().getloc() ) );
#line 58 "comp.ecpp"
  main().localcomp(request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[1]; // \n</p>\n\n\n<h2> Another local componentcall. We pass a c++-parameter. </h2>\n<p class="example">\n &lt;&amp; localcomp_p(5) &amp;&gt;\n</p>\n<p class="result">\n 
  // <& localcomp_p ...
  { 
#line 67 "comp.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 67 "comp.ecpp"
  main().localcomp_p(request, reply, _tnt_cq1, 5);
    // &>
  }
  reply.out() << data[2]; // \n</p>\n\n\n<h2>A external componentcall (localcomp "extcomp" does not exist)</h2>\n\n<p class="example">\n &lt;&amp; subcomp param1="value1" &amp;&gt;\n</p>\n<p class="result">\n 
  // <& subcomp ...
  { 
#line 77 "comp.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 77 "comp.ecpp"
    _tnt_cq2.add( "param1", tnt::toString("value1", reply.out().getloc() ) );
#line 77 "comp.ecpp"
    callComp(tnt::Compident(std::string(), "subcomp"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << data[3]; // \n</p>\n\n<h2> a external componentcall </h2>\n\n<p class="example">\n &lt;&amp; extcomp@extlib param1="value1" &amp;&gt;\n</p>\n<p class="result">\n 
  // <& extcomp@extlib ...
  { 
#line 86 "comp.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 86 "comp.ecpp"
    _tnt_cq3.add( "param1", tnt::toString("value1", reply.out().getloc() ) );
#line 86 "comp.ecpp"
    callComp(tnt::Compident("extlib", "extcomp"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << data[4]; // \n</p>\n\n<h2> a external subcomponentcall </h2>\n\n<p class="example">\n &lt;&amp; extcomp.subcomp@extlib param1="value1" &amp;&gt;\n</p>\n<p class="result">\n 
  // <& extcomp.subcomp@extlib ...
  { 
#line 95 "comp.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 95 "comp.ecpp"
    _tnt_cq4.add( "param1", tnt::toString("value1", reply.out().getloc() ) );
#line 95 "comp.ecpp"
    callComp(tnt::Subcompident("extlib", "extcomp", "subcomp"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << data[5]; // \n</p>\n\n<h2> compose componentname by expression </h2>\n
#line 99 "comp.ecpp"

  // define some variables here
  std::string compname = "extcomp";
  std::string libname = "extlib";

  reply.out() << data[6]; // \n<p class="example">\n &lt;&amp; (compname + '@' + libname) param1="value1" &amp;&gt;\n</p>\n<p class="result">\n 
  // <& (compname + '@' + libname) ...
  { 
#line 108 "comp.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 108 "comp.ecpp"
    _tnt_cq5.add( "param1", tnt::toString("value1", reply.out().getloc() ) );
#line 108 "comp.ecpp"
    callComp((compname + '@' + libname), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << data[7]; // \n</p>\n\n<h2> call component by componentidentifier </h2>\n<p class="example">\n &lt;&amp; (tnt::Compident(compname, libname)) param1="value1" &amp;&gt;\n</p>\n<p class="result">\n 
  // <& (tnt::Compident(libname, compname)) ...
  { 
#line 116 "comp.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 116 "comp.ecpp"
    _tnt_cq6.add( "param1", tnt::toString("value1", reply.out().getloc() ) );
#line 116 "comp.ecpp"
    callComp((tnt::Compident(libname, compname)), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << data[8]; // \n</p>\n\n<h2> pass a expression as parameter </h2>\n<p class="example">\n &lt;&amp; localcomp param1=(1+5) qparam param2="uhu"&amp;&gt;\n</p>\n<p class="result">\n 
  // <& localcomp ...
  { 
#line 124 "comp.ecpp"
    tnt::QueryParams _tnt_cq7(qparam);
#line 124 "comp.ecpp"
    _tnt_cq7.add( "param1", tnt::toString((1+5), reply.out().getloc() ) );
#line 124 "comp.ecpp"
    _tnt_cq7.add( "param2", tnt::toString("uhu", reply.out().getloc() ) );
#line 124 "comp.ecpp"
  main().localcomp(request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << data[9]; // \n</p>\n\n<h2> pass multiple values with the same name as parameter </h2>\n<p class="example">\n &lt;&amp; localcomp param3="value1" param3="value2"\n              param4="17" param4=(28) &amp;&gt;\n</p>\n 
  // <& localcomp ...
  { 
#line 132 "comp.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 132 "comp.ecpp"
    _tnt_cq8.add( "param3", tnt::toString("value1", reply.out().getloc() ) );
#line 132 "comp.ecpp"
    _tnt_cq8.add( "param3", tnt::toString("value2", reply.out().getloc() ) );
#line 132 "comp.ecpp"
    _tnt_cq8.add( "param4", tnt::toString("17", reply.out().getloc() ) );
#line 132 "comp.ecpp"
    _tnt_cq8.add( "param4", tnt::toString((28), reply.out().getloc() ) );
#line 132 "comp.ecpp"
  main().localcomp(request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << data[10]; // \n\n<h2> call subcomponents in c++-blocks </h2>\n<p class="example">\n  callComp("extcomp@extlib", request, reply, qparam);\n</p>\n<p class="result">\n
#line 140 "comp.ecpp"

  callComp("extcomp@extlib", request, reply, qparam);

  reply.out() << data[11]; // \n</p>\n\n</body>\n</html>\n\n
  reply.out() << data[21]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::localcomp_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("comp::localcomp " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%args>
std::string param1 = qparam.param("param1");
std::string param2 = qparam.param("param2");
typedef std::vector<std::string> param3_type;
param3_type param3;
std::copy(qparam.begin("param3"), qparam.end(), std::back_inserter(param3));
typedef std::vector<int> param4_type;
param4_type param4;
tnt::convertRange("param4", "int", qparam.begin("param4"), qparam.end(), param4, reply.out().getloc());
  // </%args>

  // <%cpp>
  reply.out() << data[12]; //    This is a local subcomponent.\n   We got a parameter <i>param1</i> with the value <b>
#line 156 "comp.ecpp"
  reply.sout() << (param1);
  reply.out() << data[13]; // </b>.\n
#line 157 "comp.ecpp"
 if (!param2.empty()) {

  reply.out() << data[14]; //    We got <i>param2</i> also. Its value is <b>
#line 158 "comp.ecpp"
  reply.sout() << (param2);
  reply.out() << data[15]; // </b>.\n
#line 159 "comp.ecpp"
 }

  reply.out() << data[16]; //   We got 
#line 160 "comp.ecpp"
  reply.sout() << ( param3.size() );
  reply.out() << data[17]; //  times "param3" and 
#line 160 "comp.ecpp"
  reply.sout() << ( param4.size() );
  reply.out() << data[18]; //  times\n  "param4".\n  The values of param3 are:\n  
#line 163 "comp.ecpp"
 std::copy(param3.begin(), param3.end(),
       std::ostream_iterator<param3_type::value_type>(reply.out(), ", ")); 
  reply.out() << data[19]; // .\n  The values of param4 are:\n  
#line 166 "comp.ecpp"
 std::copy(param4.begin(), param4.end(),
       std::ostream_iterator<param4_type::value_type>(reply.out(), ", ")); 
  reply.out() << data[20]; // .\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::localcomp_p_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam, int i)
{
  log_trace("comp::localcomp_p " << qparam.getUrl());
  tnt::DataChunks data(rawData);
  // <%cpp>
  reply.out() << data[22]; // This is a local subcomponent with parameter.\nWe got a c++-integer-parameter with the value <b>
#line 172 "comp.ecpp"
  reply.sout() << (i);
  reply.out() << data[23]; // </b>.\nThis component can only be called locally because of c++-parameters.\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
