////////////////////////////////////////////////////////////////////////
// config.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <tnt/comploader.h>
#include <tnt/tntconfig.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.config")

// <%pre>
#line 1 "config.ecpp"

#include <vector>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    // <%config>
    static std::string dburl;
    static std::vector<int> values;
    // </%config>

};

class _component_Factory : public tnt::ComponentFactoryImpl<_component_>
{
  public:
    _component_Factory()
      : tnt::ComponentFactoryImpl<_component_>("config")
      { }
    tnt::Component* doCreate(const tnt::Compident& ci,
      const tnt::Urlmapper& um, tnt::Comploader& cl);
    virtual void doConfigure(const tnt::TntConfig& config);
};

tnt::Component* _component_Factory::doCreate(const tnt::Compident& ci,
  const tnt::Urlmapper& um, tnt::Comploader& cl)
{
  return new _component_(ci, um, cl);
}

void _component_Factory::doConfigure(const tnt::TntConfig& config)
{
  // <%config>
  config.config.getMember("dburl", _component_::dburl);
  config.config.getMember("values", _component_::values);
  // </%config>
}

static _component_Factory factory;

static const char* rawData = "\030\000\000\000L\000\000\000W\000\000\000^\000\000\000b\000\000\000g\000\000\000The conf"
  "igurationvariable <i>dburl</i> is set to <b></b>.<br>\n\nvalues[] = <br>\n";

// <%shared>
// </%shared>

// <%config>
std::string _component_::dburl =  "foo";
std::vector<int> _component_::values;
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("config " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%cpp>
  reply.out() << data[0]; // The configurationvariable <i>dburl</i> is set to <b>
#line 8 "config.ecpp"
  reply.sout() << ( dburl );
  reply.out() << data[1]; // </b>.<br>\n\n
#line 10 "config.ecpp"
 for (unsigned n = 0; n < values.size(); ++n) {

  reply.out() << data[2]; // values[
#line 11 "config.ecpp"
  reply.sout() << (n);
  reply.out() << data[3]; // ] = 
#line 11 "config.ecpp"
  reply.sout() << (values[n]);
  reply.out() << data[4]; // <br>\n
#line 12 "config.ecpp"
 }

  // <%/cpp>
  return HTTP_OK;
}

} // namespace
