////////////////////////////////////////////////////////////////////////
// tooltipArea.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.tooltipArea")

// <%pre>
// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    unsigned endTag(tnt::HttpRequest& request, tnt::HttpReply& reply,
                    tnt::QueryParams& qparam);
    class js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    js_type js;
};

static tnt::ComponentFactoryImpl<_component_> Factory("tooltipArea");

static const char* rawData = "$\000\000\000\236\000\000\000\346\000\000\000\362\000\000\000\363\000\000\000\365\000\000"
  "\000\372\000\000\000\373\000\000\000\000\005\000\000\n <a onfocus=\"if (document.all)\n                this.blur();\n"
  "             return true;\"\n    onmouseover=\"showInfo('tooltip')\"\n    onmouseout=\"hideInfo();\"\n    onclick=\"r"
  "eturn false;\"\n    href=\"\"\n    class=\"\">\n</a>\n\n<script language=\"JavaScript\">\nvar mx=0,my=0,w=0,h=0,i=nul"
  "l;\n\ndocument.onmousemove = function mm(e)\n{\n    mx = (document.all \? window.event.clientX + document.body.scroll"
  "Left : e.pageX);\n    my = (document.all \? window.event.clientY + document.body.scrollTop : e.pageY);\n    refresh()"
  ";\n}\n\nfunction showInfo(id)\n{\n    hideInfo();\n    i = document.getElementById(id);\n\n    if (i)\n    {\n       "
  " w = (document.all \? document.body.offsetWidth : window.innerWidth + window.pageXOffset);\n        h = (document.all"
  " \? document.body.offsetHeight : window.innerHeight + window.pageYOffset);\n        refresh();\n    }\n}\n\nfunction "
  "hideInfo()\n{\n    if (i && i.style) i.style.visibility = \"hidden\";\n    i = null;\n}\n\nfunction refresh()\n{\n   "
  " if (i && i.style)\n    {\n        i.style.left = (mx + i.offsetWidth < w \? mx + 20 : mx - i.offsetWidth - 10) + \"p"
  "x\";\n        i.style.top  = (my + i.offsetHeight < h \? my + 20 : my - i.offsetHeight - 10) + \"px\";\n        setTi"
  "meout('if (i && i.style) i.style.visibility = \"visible\";', 0);\n    }\n}\n</script>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    js(*this, "js")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("tooltipArea " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
std::string styleClass = qparam.param("styleClass");
std::string tooltipId = qparam.param("tooltipId");
  // </%args>

  // <%cpp>
  // <& js ...
  { 
#line 5 "tooltipArea.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 5 "tooltipArea.ecpp"
  main().js(request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[0]; // \n <a onfocus="if (document.all)\n                this.blur();\n             return true;"\n    onmouseover="showInfo('tooltip
#line 9 "tooltipArea.ecpp"
  reply.sout() << ( tooltipId );
  reply.out() << data[1]; // ')"\n    onmouseout="hideInfo();"\n    onclick="return false;"\n    href=""
#line 12 "tooltipArea.ecpp"
 if (!styleClass.empty()) { 
  reply.out() << data[2]; // \n    class="
#line 13 "tooltipArea.ecpp"
  reply.sout() << (styleClass);
  reply.out() << data[3]; // "
#line 13 "tooltipArea.ecpp"
 } 
  reply.out() << data[4]; // >\n
  reply.out() << data[6]; // \n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::endTag (tnt::HttpRequest& request, tnt::HttpReply& reply,
  tnt::QueryParams& qparam)
{
  tnt::DataChunks data(rawData);
  // <%cpp>
  reply.out() << data[5]; // </a>\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("tooltipArea::js " << qparam.getUrl());
  tnt::DataChunks data(rawData);
#line 20 "tooltipArea.ecpp"
  typedef bool tooltipJs_type;
  TNT_REQUEST_COMPONENT_VAR(tooltipJs_type, tooltipJs, "bool tooltipJs", (false));   // <%request> bool tooltipJs(false)
  // <%cpp>
#line 22 "tooltipArea.ecpp"
 if (!tooltipJs) {

  reply.out() << data[7]; // <script language="JavaScript">\nvar mx=0,my=0,w=0,h=0,i=null;\n\ndocument.onmousemove = function mm(e)\n{\n    mx = (document.all \? window.event.clientX + document.body.scrollLeft : e.pageX);\n    my = (document.all \? window.event.clientY + document.body.scrollTop : e.pageY);\n    refresh();\n}\n\nfunction showInfo(id)\n{\n    hideInfo();\n    i = document.getElementById(id);\n\n    if (i)\n    {\n        w = (document.all \? document.body.offsetWidth : window.innerWidth + window.pageXOffset);\n        h = (document.all \? document.body.offsetHeight : window.innerHeight + window.pageYOffset);\n        refresh();\n    }\n}\n\nfunction hideInfo()\n{\n    if (i && i.style) i.style.visibility = "hidden";\n    i = null;\n}\n\nfunction refresh()\n{\n    if (i && i.style)\n    {\n        i.style.left = (mx + i.offsetWidth < w \? mx + 20 : mx - i.offsetWidth - 10) + "px";\n        i.style.top  = (my + i.offsetHeight < h \? my + 20 : my - i.offsetHeight - 10) + "px";\n        setTimeout('if (i && i.style) i.style.visibility = "visible";', 0);\n    }\n}\n</script>\n
#line 62 "tooltipArea.ecpp"
   tooltipJs = true;

#line 63 "tooltipArea.ecpp"
 }

  // <%/cpp>
  return HTTP_OK;
}

} // namespace
