////////////////////////////////////////////////////////////////////////
// treeview.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.treeview")

// <%pre>
// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    unsigned endTag(tnt::HttpRequest& request, tnt::HttpReply& reply,
                    tnt::QueryParams& qparam);
    class javascript_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        javascript_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    javascript_type javascript;
};

static tnt::ComponentFactoryImpl<_component_> Factory("treeview");

static const char* rawData = "0\000\000\0001\000\000\0002\000\000\000T\000\000\000X\000\000\000\177\000\000\000\202\000"
  "\000\000\262\000\000\000\271\000\000\000\274\000\000\000\303\000\000\000M\004\000\000\n\n<a onclick='treeviewToggle(t"
  "his, \"\", \"\");' style='cursor:pointer;'><img src=\"\"> <br></a>\n<div style=\"padding-left:20px; display:;\" id=\""
  "\">\n</div>\n  <script language=\"JavaScript\">\n   function treeviewToggle(node, imgOpen, imgClose)\n   {\n     var "
  "n = node.nextSibling;\n     while (n != null && n.nodeType == 3) // type 3: text\n       n = n.nextSibling;\n     if "
  "(n != null)\n     {\n       var open = (n.style.display == \"none\");\n       n.style.display = (open \? \"block\" : "
  "\"none\");\n       var c = node.firstChild;\n       if (c.nodeName == \"IMG\")\n         c.src = (open \? imgOpen : i"
  "mgClose);\n\n       var states = document.getElementsByName(\"treeviewState\");\n       var state = document.getEleme"
  "ntById(\"treeviewState\");\n       if (state != null)\n         states.push(state);\n       var id = ':' + n.id;\n   "
  "    for (var i = 0; i < states.length; ++i)\n       {\n         var state = states[i];\n         if (open)\n         "
  "  state.value += id;\n         else\n           state.value = state.value.replace(new RegExp(id, \"g\"), '');\n      "
  " }\n     }\n   }\n  </script>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    javascript(*this, "javascript")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("treeview " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
std::string label = qparam.param("label");
std::string id = qparam.param("id");
std::string treeviewState = qparam.param("treeviewState");
std::string imgOpen = qparam.param("imgOpen", ( "minus.png"));
std::string imgClose = qparam.param("imgClose", ( "plus.png"));
  // </%args>

  // <%cpp>
  reply.out() << data[0]; // \n
  // <& javascript ...
  { 
#line 34 "treeview.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 34 "treeview.ecpp"
  main().javascript(request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[1]; // \n
#line 35 "treeview.ecpp"


  bool open = (treeviewState.find(':' + id) != std::string::npos);
  std::string displayStyle = (open ? "block" : "none");
  std::string img          = (open ? imgOpen : imgClose);


  reply.out() << data[2]; // <a onclick='treeviewToggle(this, "
#line 42 "treeview.ecpp"
  reply.sout() << (imgOpen);
  reply.out() << data[3]; // ", "
#line 42 "treeview.ecpp"
  reply.sout() << (imgClose);
  reply.out() << data[4]; // ");' style='cursor:pointer;'><img src="
#line 42 "treeview.ecpp"
  reply.sout() << (img);
  reply.out() << data[5]; // "> 
#line 42 "treeview.ecpp"
  reply.sout() << ( label );
  reply.out() << data[6]; // <br></a>\n<div style="padding-left:20px; display:
#line 43 "treeview.ecpp"
  reply.sout() << ( displayStyle );
  reply.out() << data[7]; // ;" id="
#line 43 "treeview.ecpp"
  reply.sout() << (id);
  reply.out() << data[8]; // ">\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::endTag (tnt::HttpRequest& request, tnt::HttpReply& reply,
  tnt::QueryParams& qparam)
{
  tnt::DataChunks data(rawData);
  // <%cpp>
  reply.out() << data[9]; // </div>\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::javascript_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("treeview::javascript " << qparam.getUrl());
  tnt::DataChunks data(rawData);
#line 49 "treeview.ecpp"
  typedef bool js_type;
  TNT_REQUEST_COMPONENT_VAR(js_type, js, "bool js", (false));   // <%request> bool js(false)
  // <%cpp>
#line 51 "treeview.ecpp"
 if (!js) {

  reply.out() << data[10]; //   <script language="JavaScript">\n   function treeviewToggle(node, imgOpen, imgClose)\n   {\n     var n = node.nextSibling;\n     while (n != null && n.nodeType == 3) // type 3: text\n       n = n.nextSibling;\n     if (n != null)\n     {\n       var open = (n.style.display == "none");\n       n.style.display = (open \? "block" : "none");\n       var c = node.firstChild;\n       if (c.nodeName == "IMG")\n         c.src = (open \? imgOpen : imgClose);\n\n       var states = document.getElementsByName("treeviewState");\n       var state = document.getElementById("treeviewState");\n       if (state != null)\n         states.push(state);\n       var id = ':' + n.id;\n       for (var i = 0; i < states.length; ++i)\n       {\n         var state = states[i];\n         if (open)\n           state.value += id;\n         else\n           state.value = state.value.replace(new RegExp(id, "g"), '');\n       }\n     }\n   }\n  </script>\n
#line 82 "treeview.ecpp"
   js = true;

#line 83 "treeview.ecpp"
 }

  // <%/cpp>
  return HTTP_OK;
}

} // namespace
