////////////////////////////////////////////////////////////////////////
// get.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.get")

// <%pre>
#line 5 "get.ecpp"


#include "message.h"
#include <cxxtools/jsonserializer.h>


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("get");

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("get " << qparam.getUrl());


  // <%args>
unsigned serial = qparam.has("serial") ? tnt::stringToWithDefault<unsigned>(qparam.param("serial"), ( 0), reply.out().getloc()) : ( 0);
unsigned timeout = qparam.has("timeout") ? tnt::stringToWithDefault<unsigned>(qparam.param("timeout"), ( 0), reply.out().getloc()) : ( 0);
  // </%args>

  // <%cpp>
#line 11 "get.ecpp"


log_debug("serial=" << serial << " timeout=" << timeout);
MessageType::ValueSerial value = message.get(serial, timeout);

log_debug("return serial=" << value.second << " value=\"" << value.first.narrow() << '"');

cxxtools::JsonSerializer serializer;
serializer.begin(reply.out())
          .serialize(value.first, "value")
          .serialize(value.second, "serial")
          .finish();


  // <%/cpp>
  return HTTP_OK;
}

} // namespace
