////////////////////////////////////////////////////////////////////////
// message.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.message")

// <%pre>
#line 1 "message.ecpp"

#include "message.h"
#include <cxxtools/utf8codec.h>

MessageType message;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("message");

static const char* rawData = "\010\000\000\000K\005\000\000<html>\n <head>\n  <title>Message demo application</title>\n"
  "  <script type=\"text/javascript\" src=\"jquery.js\"></script>\n  <script type=\"text/javascript\">\n\n      var seri"
  "al = 0;\n\n      function runQuery()\n      {\n        $.getJSON(\"/get\",\n          {\n            \"timeout\" : 60"
  "000,\n            \"serial\" : serial\n          },\n          function (result) {\n            if (result.serial != "
  "serial)\n            {\n              $(\"#serial\").html(result.value)\n                .css(\"background-color\", "
  "\"green\");\n              window.setTimeout(\"$('#serial').css('background-color', 'white')\", 800)\n              s"
  "erial = result.serial;\n            }\n\n            runQuery()\n          })\n      }\n\n      $(function() {\n     "
  "   runQuery()\n      })\n\n  </script>\n\n </head>\n <body>\n  <h1>Message</h1>\n  <p>\n   This demo shows how to use"
  " jquery and json to realize a reverse ajax\n   application. To see it in action you need 2 (or more) browser windows,"
  " which\n   look at the page. Each browser starts a reverse ajax request to monitor\n   changes in the sent message. W"
  "hen you enter a text here and submit it to the\n   server, the server sends this message to each browser immediately."
  "\n  </p>\n  <form method=\"post\">\n   <input type=\"text\" name=\"value\">\n   <input type=\"submit\" name=\"set\" i"
  "d=\"set\" value=\"send\">\n  </form>\n\n  <div id=\"serial\"></div>\n\n </body>\n</html>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("message " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
std::string value = qparam.param("value");
  // </%args>

  // <%cpp>
#line 11 "message.ecpp"


if (!value.empty())
{
  log_info("set value to \"" << value << '"');
  message.set(cxxtools::Utf8Codec::decode(value));
}


  reply.out() << data[0]; // <html>\n <head>\n  <title>Message demo application</title>\n  <script type="text/javascript" src="jquery.js"></script>\n  <script type="text/javascript">\n\n      var serial = 0;\n\n      function runQuery()\n      {\n        $.getJSON("/get",\n          {\n            "timeout" : 60000,\n            "serial" : serial\n          },\n          function (result) {\n            if (result.serial != serial)\n            {\n              $("#serial").html(result.value)\n                .css("background-color", "green");\n              window.setTimeout("$('#serial').css('background-color', 'white')", 800)\n              serial = result.serial;\n            }\n\n            runQuery()\n          })\n      }\n\n      $(function() {\n        runQuery()\n      })\n\n  </script>\n\n </head>\n <body>\n  <h1>Message</h1>\n  <p>\n   This demo shows how to use jquery and json to realize a reverse ajax\n   application. To see it in action you need 2 (or more) browser windows, which\n   look at the page. Each browser starts a reverse ajax request to monitor\n   changes in the sent message. When you enter a text here and submit it to the\n   server, the server sends this message to each browser immediately.\n  </p>\n  <form method="post">\n   <input type="text" name="value">\n   <input type="submit" name="set" id="set" value="send">\n  </form>\n\n  <div id="serial"></div>\n\n </body>\n</html>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
