////////////////////////////////////////////////////////////////////////
// savepoint.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.savepoint")

// <%pre>
#line 1 "savepoint.ecpp"


#include <tnt/savepoint.h>


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("savepoint");

static const char* rawData = "\024\000\000\000;\000\000\000S\000\000\000`\000\000\000\265\000\000\000<html>\n<body>\n <"
  "h1>savepoint-demo</h1>\n\n\n    <h2>\n     Title2\n\n\n\n    </h2>\n\n\n  This is no header, because the h2-tag is re"
  "moved from the output.\n</body>\n</html>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("savepoint " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%cpp>
  reply.out() << data[0]; // <html>\n<body>\n <h1>savepoint-demo</h1>\n
#line 9 "savepoint.ecpp"


  try
  {
    tnt::Savepoint sv(reply);

    // everything from here until catch is not sent, because
    // the exception rolls back the savepoint


  reply.out() << data[1]; // \n\n    <h2>\n     Title2\n\n
#line 23 "savepoint.ecpp"


  throw std::runtime_error("test"); // this skips end-tag "</h2>"


  reply.out() << data[2]; // \n\n    </h2>\n\n
#line 31 "savepoint.ecpp"


    sv.commit();
  }
  catch (const std::exception& e)
  {
    reply.out() << e.what() << std::endl;
  }


  reply.out() << data[3]; // \n  This is no header, because the h2-tag is removed from the output.\n</body>\n</html>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
