////////////////////////////////////////////////////////////////////////
// session.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.session")

// <%pre>
#line 1 "session.ecpp"


class MyClass
{
  public:
    MyClass()
    {
      log_debug("MyClass ctor");
    }
    ~MyClass()
    {
      log_debug("MyClass dtor");
    }
};


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class subcomp_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        subcomp_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    subcomp_type subcomp;
};

static tnt::ComponentFactoryImpl<_component_> Factory("session");

static const char* rawData = "p\000\000\000\215\000\000\000\260\000\000\000\314\000\000\000\364\000\000\000\036\001\000"
  "\000A\001\000\000f\001\000\000\206\001\000\000\247\001\000\000\303\001\000\000\343\001\000\000\376\001\000\000(\002"
  "\000\000\207\002\000\000\212\002\000\000\214\002\000\000\216\002\000\000\220\002\000\000\310\002\000\000\346\002\000"
  "\000\015\003\000\000/\003\000\000R\003\000\000p\003\000\000\222\003\000\000\257\003\000\000\265\003\000\000\nSessionc"
  "ounter (component): <br>\nSessioncounter (application): <br>\nSessioncounter (page): <br>\nSecure sessioncounter (com"
  "ponent): <br>\nSecure sessioncounter (application): <br>\nSecure sessioncounter (page): <br>\nApplicationcounter (com"
  "ponent): <br>\nApplicationcounter (page): <br>\nRequestcounter (component): <br>\nRequestcounter (page): <br>\nThread"
  "counter (component): <br>\nThreadcounter (page): <br>\n\n<div style=\"background-color:#ffa\">\n\n</div>\n\n<a href="
  "\"session\">reload this</a> -\n<a href=\"appsession\">applicationsession only</a>\n\n\n        \n  <h1>Subcomponent</"
  "h1>\n\n  Sessioncounter (component): <br>\n  Sessioncounter (page): <br>\n  Applicationcounter (component): <br>\n  A"
  "pplicationcounter (page): <br>\n  Requestcounter (component): <br>\n  Requestcounter (page): <br>\n  Threadcounter (c"
  "omponent): <br>\n  Threadcounter (page): <br>\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    subcomp(*this, "subcomp")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("session " << qparam.getUrl());

  tnt::DataChunks data(rawData);

#line 19 "session.ecpp"
  typedef unsigned s_type;
  TNT_SESSION_COMPONENT_VAR(s_type, s, "unsigned s", (0));   // <%session> unsigned s(0)
#line 24 "session.ecpp"
  typedef unsigned sa_type;
  TNT_SESSION_GLOBAL_VAR(sa_type, sa, "unsigned sa", (0));   // <%session> unsigned sa(0)
#line 29 "session.ecpp"
  typedef unsigned sp_type;
  TNT_SESSION_PAGE_VAR(sp_type, sp, "unsigned sp", (0));   // <%session> unsigned sp(0)
#line 30 "session.ecpp"
  typedef MyClass myObject_type;
  TNT_SESSION_PAGE_VAR(myObject_type, myObject, "MyClass myObject", ());   // <%session> MyClass myObject
#line 35 "session.ecpp"
  typedef unsigned ss_type;
  TNT_SECURE_SESSION_COMPONENT_VAR(ss_type, ss, "unsigned ss", (0));   // <%securesession> unsigned ss(0)
#line 40 "session.ecpp"
  typedef unsigned ssa_type;
  TNT_SECURE_SESSION_GLOBAL_VAR(ssa_type, ssa, "unsigned ssa", (0));   // <%securesession> unsigned ssa(0)
#line 45 "session.ecpp"
  typedef unsigned ssp_type;
  TNT_SECURE_SESSION_PAGE_VAR(ssp_type, ssp, "unsigned ssp", (0));   // <%securesession> unsigned ssp(0)
#line 50 "session.ecpp"
  typedef unsigned a_type;
  TNT_APPLICATION_COMPONENT_VAR(a_type, a, "unsigned a", (0));   // <%application> unsigned a(0)
#line 55 "session.ecpp"
  typedef unsigned ap_type;
  TNT_APPLICATION_PAGE_VAR(ap_type, ap, "unsigned ap", (0));   // <%application> unsigned ap(0)
#line 60 "session.ecpp"
  typedef unsigned r_type;
  TNT_REQUEST_COMPONENT_VAR(r_type, r, "unsigned r", (0));   // <%request> unsigned r(0)
#line 65 "session.ecpp"
  typedef unsigned rp_type;
  TNT_REQUEST_PAGE_VAR(rp_type, rp, "unsigned rp", (0));   // <%request> unsigned rp(0)
#line 70 "session.ecpp"
  typedef unsigned t_type;
  TNT_THREAD_COMPONENT_VAR(t_type, t, "unsigned t", (0));   // <%thread> unsigned t(0)
#line 75 "session.ecpp"
  typedef unsigned tp_type;
  TNT_THREAD_PAGE_VAR(tp_type, tp, "unsigned tp", (0));   // <%thread> unsigned tp(0)
  // <%cpp>
#line 78 "session.ecpp"


MyClass* p = request.getSessionScope().get<MyClass>("foo");
if (p)
{
  log_debug("instance of MyClass found");
}
else
{
  log_debug("create instance of MyClass");
  p = new MyClass();

  log_debug("put instance of MyClass into session scope");
  request.getSessionScope().put("foo", p); // ownership is transfered to the scope here
}


  reply.out() << data[0]; // \nSessioncounter (component): 
#line 96 "session.ecpp"
  reply.sout() << ( ++s );
  reply.out() << data[1]; // <br>\nSessioncounter (application): 
#line 97 "session.ecpp"
  reply.sout() << ( ++sa );
  reply.out() << data[2]; // <br>\nSessioncounter (page): 
#line 98 "session.ecpp"
  reply.sout() << ( ++sp );
  reply.out() << data[3]; // <br>\nSecure sessioncounter (component): 
#line 99 "session.ecpp"
  reply.sout() << ( ++ss );
  reply.out() << data[4]; // <br>\nSecure sessioncounter (application): 
#line 100 "session.ecpp"
  reply.sout() << ( ++ssa );
  reply.out() << data[5]; // <br>\nSecure sessioncounter (page): 
#line 101 "session.ecpp"
  reply.sout() << ( ++ssp );
  reply.out() << data[6]; // <br>\nApplicationcounter (component): 
#line 102 "session.ecpp"
  reply.sout() << ( ++a );
  reply.out() << data[7]; // <br>\nApplicationcounter (page): 
#line 103 "session.ecpp"
  reply.sout() << ( ++ap );
  reply.out() << data[8]; // <br>\nRequestcounter (component): 
#line 104 "session.ecpp"
  reply.sout() << ( ++r );
  reply.out() << data[9]; // <br>\nRequestcounter (page): 
#line 105 "session.ecpp"
  reply.sout() << ( ++rp );
  reply.out() << data[10]; // <br>\nThreadcounter (component): 
#line 106 "session.ecpp"
  reply.sout() << ( ++t );
  reply.out() << data[11]; // <br>\nThreadcounter (page): 
#line 107 "session.ecpp"
  reply.sout() << ( ++tp );
  reply.out() << data[12]; // <br>\n\n<div style="background-color:#ffa">\n
  // <& subcomp ...
  { 
#line 110 "session.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 110 "session.ecpp"
  main().subcomp(request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << data[13]; // \n</div>\n\n<a href="session">reload this</a> -\n<a href="appsession">applicationsession only</a>\n\n
  // <%/cpp>
  return HTTP_OK;
}

unsigned _component_::subcomp_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("session::subcomp " << qparam.getUrl());
  tnt::DataChunks data(rawData);
#line 120 "session.ecpp"
  typedef unsigned s_type;
  TNT_SESSION_COMPONENT_VAR(s_type, s, "unsigned s", (0));   // <%session> unsigned s(0)
#line 125 "session.ecpp"
  typedef unsigned a_type;
  TNT_APPLICATION_COMPONENT_VAR(a_type, a, "unsigned a", (0));   // <%application> unsigned a(0)
#line 130 "session.ecpp"
  typedef unsigned r_type;
  TNT_REQUEST_COMPONENT_VAR(r_type, r, "unsigned r", (0));   // <%request> unsigned r(0)
#line 135 "session.ecpp"
  typedef unsigned t_type;
  TNT_THREAD_COMPONENT_VAR(t_type, t, "unsigned t", (0));   // <%thread> unsigned t(0)
#line 29 "session.ecpp"
  typedef unsigned sp_type;
  TNT_SESSION_PAGE_VAR(sp_type, sp, "unsigned sp", (0));   // <%session> unsigned sp(0)
#line 30 "session.ecpp"
  typedef MyClass myObject_type;
  TNT_SESSION_PAGE_VAR(myObject_type, myObject, "MyClass myObject", ());   // <%session> MyClass myObject
#line 45 "session.ecpp"
  typedef unsigned ssp_type;
  TNT_SECURE_SESSION_PAGE_VAR(ssp_type, ssp, "unsigned ssp", (0));   // <%securesession> unsigned ssp(0)
#line 55 "session.ecpp"
  typedef unsigned ap_type;
  TNT_APPLICATION_PAGE_VAR(ap_type, ap, "unsigned ap", (0));   // <%application> unsigned ap(0)
#line 65 "session.ecpp"
  typedef unsigned rp_type;
  TNT_REQUEST_PAGE_VAR(rp_type, rp, "unsigned rp", (0));   // <%request> unsigned rp(0)
#line 75 "session.ecpp"
  typedef unsigned tp_type;
  TNT_THREAD_PAGE_VAR(tp_type, tp, "unsigned tp", (0));   // <%thread> unsigned tp(0)
#line 24 "session.ecpp"
  typedef unsigned sa_type;
  TNT_SESSION_GLOBAL_VAR(sa_type, sa, "unsigned sa", (0));   // <%session> unsigned sa(0)
#line 40 "session.ecpp"
  typedef unsigned ssa_type;
  TNT_SECURE_SESSION_GLOBAL_VAR(ssa_type, ssa, "unsigned ssa", (0));   // <%securesession> unsigned ssa(0)
  // <%cpp>
  reply.out() << data[14]; // \n  
  reply.out() << data[15]; //   
  reply.out() << data[16]; //   
  reply.out() << data[17]; //   
  reply.out() << data[18]; // \n  <h1>Subcomponent</h1>\n\n  Sessioncounter (component): 
#line 141 "session.ecpp"
  reply.sout() << ( ++s );
  reply.out() << data[19]; // <br>\n  Sessioncounter (page): 
#line 142 "session.ecpp"
  reply.sout() << ( ++sp );
  reply.out() << data[20]; // <br>\n  Applicationcounter (component): 
#line 143 "session.ecpp"
  reply.sout() << ( ++a );
  reply.out() << data[21]; // <br>\n  Applicationcounter (page): 
#line 144 "session.ecpp"
  reply.sout() << ( ++ap );
  reply.out() << data[22]; // <br>\n  Requestcounter (component): 
#line 145 "session.ecpp"
  reply.sout() << ( ++r );
  reply.out() << data[23]; // <br>\n  Requestcounter (page): 
#line 146 "session.ecpp"
  reply.sout() << ( ++rp );
  reply.out() << data[24]; // <br>\n  Threadcounter (component): 
#line 147 "session.ecpp"
  reply.sout() << ( ++t );
  reply.out() << data[25]; // <br>\n  Threadcounter (page): 
#line 148 "session.ecpp"
  reply.sout() << ( ++tp );
  reply.out() << data[26]; // <br>\n\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
