////////////////////////////////////////////////////////////////////////
// strings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.strings")

// <%pre>
#line 1 "strings.ecpp"


#include <vector>
#include <limits>


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("strings");

static const char* rawData = "\034\000\000\000\233\001\000\000\247\001\000\000\265\001\000\000\331\001\000\000\363\001"
  "\000\000\024\002\000\000\n<html>\n <head><title>Example ECPP</title></head>\n <body> \n  <h1>Example ECPP</h1>\n\n   "
  "<p>This servlet enters strings into a table.</p>\n\n   <form method=get> \n    <p>Enter a string:\n    <input type=te"
  "xt size=64 name=\"string\"></input>\n    <input type=submit name=\"add\" value=\"Go!\"></input>\n    </p> \n   </form"
  ">\n <p>\n\n <table border=1> \n  <tr>\n   <th colspan=2>Strings entered so far: </th></tr>\n \n <tr> \n  <td></td>\n "
  " <td><a href=\"strings\?remove=\">remove</a></td> \n</tr>\n  \n</table></p> \n</body> \n</html>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("strings " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%args>
bool add = tnt::stringTo<bool>("add", "bool", qparam.param("add"), reply.out().getloc());
std::string string = qparam.param("string");
unsigned remove = qparam.has("remove") ? tnt::stringToWithDefault<unsigned>(qparam.param("remove"), ( std::numeric_limits<unsigned>::max()), reply.out().getloc()) : ( std::numeric_limits<unsigned>::max());
  // </%args>

#line 8 "strings.ecpp"
  typedef std::vector<std::string> strings_type;
  TNT_SESSION_COMPONENT_VAR(strings_type, strings, "std::vector<std::string> strings", ());   // <%session> std::vector<std::string> strings
  // <%cpp>
#line 15 "strings.ecpp"


  if (add)
    strings.push_back(string);

  if (remove < strings.size())
    strings.erase(strings.begin() + remove);


  reply.out() << data[0]; // \n<html>\n <head><title>Example ECPP</title></head>\n <body> \n  <h1>Example ECPP</h1>\n\n   <p>This servlet enters strings into a table.</p>\n\n   <form method=get> \n    <p>Enter a string:\n    <input type=text size=64 name="string"></input>\n    <input type=submit name="add" value="Go!"></input>\n    </p> \n   </form>\n <p>\n\n <table border=1> \n  <tr>\n   <th colspan=2>Strings entered so far: 
#line 41 "strings.ecpp"
  reply.sout() << (strings.size());
  reply.out() << data[1]; // </th></tr>\n 
#line 42 "strings.ecpp"
 
   for (std::vector<std::string>::const_iterator i = strings.begin();
        i != strings.end(); ++i) { 
  
  reply.out() << data[2]; // \n <tr> \n  <td>
#line 47 "strings.ecpp"
  reply.sout() << ( *i );
  reply.out() << data[3]; // </td>\n  <td><a href="strings\?remove=
#line 48 "strings.ecpp"
  reply.sout() << (i - strings.begin());
  reply.out() << data[4]; // ">remove</a></td> \n</tr>\n 
#line 50 "strings.ecpp"
 
} 

  reply.out() << data[5]; //  \n</table></p> \n</body> \n</html>\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
