////////////////////////////////////////////////////////////////////////
// upload.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/convert.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.upload")

// <%pre>
#line 1 "upload.ecpp"

#include <cxxtools/hdstream.h>
#include <cxxtools/md5stream.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::ComponentFactoryImpl<_component_> Factory("upload");

static const char* rawData = " \000\000\0002\000\000\000\263\000\000\000\301\000\000\000\341\000\000\000\373\000\000"
  "\000\014\001\000\000\037\001\000\000<html>\n <body>\n\n  \n  <form method=\"post\" enctype=\"multipart/form-data\">\n"
  "\n   <input type=\"file\" name=\"upload\">\n   <input type=\"submit\">\n\n  </form>\n\n\n\n    <p>\n     bytes receiv"
  "ed<br>\n    md5sum: <br>\n    data:<br>\n\n<pre>\n\n</pre>\n    </p>\n\n </body>\n</html>\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

#define SET_LANG(lang) \
     do \
     { \
       request.setLang(lang); \
       reply.setLocale(request.getLocale()); \
     } while (false)

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("upload " << qparam.getUrl());

  tnt::DataChunks data(rawData);

  // <%cpp>
  reply.out() << data[0]; // <html>\n <body>\n\n  
  reply.out() << data[1]; // \n  <form method="post" enctype="multipart/form-data">\n\n   <input type="file" name="upload">\n   <input type="submit">\n\n  </form>\n\n
#line 16 "upload.ecpp"


  // request.getMultipart() gives us access to all parts of
  // the multipart-encoded request
  const tnt::Multipart& mp = request.getMultipart();

  // we look for a part named like our name-attribute of the upload-field
  tnt::Multipart::const_iterator it = mp.find("upload");

  if (it != mp.end())
  {
    // we got a const-iterator to the uploaded data

    cxxtools::Md5stream md5stream;
    std::copy(it->getBodyBegin(),
              it->getBodyEnd(),
              std::ostreambuf_iterator<char>(md5stream));

  reply.out() << data[2]; // \n\n    <p>\n    
#line 36 "upload.ecpp"
  reply.sout() << ( it->getSize() );
  reply.out() << data[3]; //  bytes received<br>\n    md5sum: 
#line 37 "upload.ecpp"
  reply.sout() << ( md5stream.getHexDigest() );
  reply.out() << data[4]; // <br>\n    data:<br>\n\n<pre>\n
#line 41 "upload.ecpp"


  // cxxtools::Hdostream is a outstream, which converts the data to a hexdump
  // and prints it to a target-ostream. "reply.out()" gives us a ostream
  // to our client.

  cxxtools::Hdostream hd(reply.sout());

  // hexdump first 1k of uploaded file
  if (it->getSize() > 1024)
  {
    std::copy(it->getBodyBegin(),
              it->getBodyBegin() + 1024,
              std::ostreambuf_iterator<char>(hd));
  }
  else
  {
    std::copy(it->getBodyBegin(),
              it->getBodyEnd(),
              std::ostreambuf_iterator<char>(hd));
  }

  // print last line
  hd.flush();


  reply.out() << data[5]; // \n</pre>\n    </p>\n
#line 69 "upload.ecpp"

  }

  reply.out() << data[6]; // \n </body>\n</html>\n\n
  // <%/cpp>
  return HTTP_OK;
}

} // namespace
